#include <stdio.h>


//TODO: ecrire le corps de la 
//fonction fusion ci-dessous
//dans le fichier TODOmerge.h
/*!
************************************************
* \brief remplit un tableau trie de 2N elements en 
* fusionnant deux tableaux de N elements tries
* \param T un tableau de N entiers
* \param N taille du tableau T
* \param S un deuxième tableau de N entiers
* \param M taille du tableau S
* \param TS un tableau de N+M entiers issu de la fusion
* des deux premiers tableaux.
* \warning Le tableau TS est deja alloue mais vide
**************************************************/    
void fusion(int T[], int N, int S[], int M, int TS[]); 

#include "TODOmerge.h"

/*!
************************************************
* \brief Fusionne deux tableaux tries en un troisième, 
* affiche a l'ecran les tableaux et teste si le 
* troisième tableau est trie.
* \see fusion  
* \param T un tableau de N entiers
* \param N taille du tableau T
* \param S un deuxième tableau de N entiers
* \param M taille du tableau S
* \param TS un tableau de N+M entiers issu de la fusion
* des deux premiers tableaux.
* \return 1 si TS est trie, 0 sinon
**************************************************/    
int test(int T[], int N, int S[], int M, int TS[])
{
  int i; //indice de boucle
  int estTrie; //1 si le tableau est trie, 0 sinon

  //calcul de la fusion TS
  fusion(T,N,S,M,TS);

  //affichage des tableaux
  printf("Tableaux initiaux:\n");
  for (i=0;i<N;i++)
    {
      printf("%d ",T[i]);
    }
  printf("\n");
  for (i=0;i<M;i++)
    {
      printf("%d ",S[i]);
    }
  printf("\n");
  printf("Tableau fusionne:\n");
  for (i=0;i<(N+M);i++)
    {
      printf("%d ",TS[i]);
    }
  printf("\n");

  //test
  estTrie = 1; 
  for (i=1;i<(N+M);i++)
    {
      if (TS[i] < TS[i-1])
	estTrie = 0;  
    }
  if (estTrie)
    printf("PASSED");
  else
    printf("FAILED"); 
  printf("\n");

  return estTrie ? 1 : 0;
}

/*!
************************************************
* \brief Teste la fusion de deux tableaux tries 
* de N entiers en un tableau trie de 2N entiers. 
* \see test
**************************************************/    
int main()
{
  int estTrie; //1 si les tableaux sont tries, 0 sinon
  estTrie = 1; 

  { //test 1
    int T[10] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10}; 
    int S[12] = {11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 22, 24}; 

    int TS[22]; 
    estTrie = estTrie && test(T, 10, S, 12, TS); 
  }
  { //test 2
    int T[10] = {11, 12, 13, 14, 15, 16, 17, 18, 19, 20}; 
    int S[12] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12}; 

    int TS[22]; 
    estTrie = estTrie && test(T, 10, S, 12, TS); 
  }
  { //test 3
    int T[10] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10}; 
    int S[12] = {2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24}; 

    int TS[22]; 
    estTrie = estTrie && test(T, 10, S, 12, TS); 
  }
  { //test 4
    int T[10] = {2, 4, 6, 8, 10, 12, 14, 16, 18, 20}; 
    int S[12] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12}; 

    int TS[22]; 
    estTrie = estTrie && test(T, 10, S, 12, TS); 
  }

  return estTrie ? 0 : 1;
}
